]> git.ipfire.org Git - thirdparty/git.git/blame - git-merge.sh
sh-setup: don't let eval output to be shell-expanded.
[thirdparty/git.git] / git-merge.sh
CommitLineData
91063bbc
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
b0bf1d8b
PH
6OPTIONS_KEEPDASHDASH=
7OPTIONS_SPEC="\
8git-merge [options] <remote>...
9git-merge [options] <msg> HEAD <remote>
10--
11summary show a diffstat at the end of the merge
12n,no-summary don't show a diffstat at the end of the merge
13squash create a single commit instead of doing a merge
14commit perform a commit if the merge sucesses (default)
15ff allow fast forward (default)
16s,strategy= merge strategy to use
17m,message= message to be used for the merge commit (if any)
18"
17bcdad3 19
533b7039 20SUBDIRECTORY_OK=Yes
ae2b0f15 21. git-sh-setup
7eff28a9 22require_work_tree
533b7039 23cd_to_toplevel
91063bbc 24
d1014a17 25test -z "$(git ls-files -u)" ||
533b7039 26 die "You are in the middle of a conflicted merge."
d1014a17 27
91063bbc
JH
28LF='
29'
30
68faf689 31all_strategies='recur recursive octopus resolve stupid ours subtree'
a06f678e 32default_twohead_strategies='recursive'
6ea23343 33default_octopus_strategies='octopus'
a0050852
JH
34no_fast_forward_strategies='subtree ours'
35no_trivial_strategies='recursive recur subtree ours'
91063bbc 36use_strategies=
6ea23343 37
a0050852
JH
38allow_fast_forward=t
39allow_trivial_merge=t
91063bbc 40
a9358240 41dropsave() {
deca7e8c 42 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
a9358240
JH
43 "$GIT_DIR/MERGE_SAVE" || exit 1
44}
45
46savestate() {
60fa0560 47 # Stash away any local modifications.
5be60078 48 git diff-index -z --name-only $head |
88f8f0a5 49 cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
a9358240
JH
50}
51
52restorestate() {
deca7e8c
JH
53 if test -f "$GIT_DIR/MERGE_SAVE"
54 then
228e2eb6 55 git reset --hard $head >/dev/null
deca7e8c 56 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
5be60078 57 git update-index --refresh >/dev/null
deca7e8c 58 fi
91063bbc
JH
59}
60
7d0c6887
JH
61finish_up_to_date () {
62 case "$squash" in
63 t)
64 echo "$1 (nothing to squash)" ;;
65 '')
66 echo "$1" ;;
67 esac
68 dropsave
69}
70
71squash_message () {
72 echo Squashed commit of the following:
73 echo
2ae4fd76 74 git log --no-merges ^"$head" $remoteheads
7d0c6887
JH
75}
76
4f692b19 77finish () {
e1447e38
SP
78 if test '' = "$2"
79 then
f9474132 80 rlogm="$GIT_REFLOG_ACTION"
e1447e38
SP
81 else
82 echo "$2"
f9474132 83 rlogm="$GIT_REFLOG_ACTION: $2"
e1447e38 84 fi
7d0c6887
JH
85 case "$squash" in
86 t)
87 echo "Squash commit -- not updating HEAD"
88 squash_message >"$GIT_DIR/SQUASH_MSG"
4f692b19 89 ;;
7d0c6887
JH
90 '')
91 case "$merge_msg" in
92 '')
93 echo "No merge message -- not updating HEAD"
94 ;;
95 *)
5be60078 96 git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
d4bb43ee 97 git gc --auto
7d0c6887
JH
98 ;;
99 esac
4f692b19
JH
100 ;;
101 esac
7d0c6887 102 case "$1" in
91063bbc 103 '')
7d0c6887
JH
104 ;;
105 ?*)
51e7ecf4
AR
106 if test "$show_diffstat" = t
107 then
fefe49d1 108 # We want color (if set), but no pager
5be60078 109 GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
51e7ecf4 110 fi
91063bbc
JH
111 ;;
112 esac
46232915
JE
113
114 # Run a post-merge hook
115 if test -x "$GIT_DIR"/hooks/post-merge
116 then
117 case "$squash" in
118 t)
119 "$GIT_DIR"/hooks/post-merge 1
120 ;;
121 '')
122 "$GIT_DIR"/hooks/post-merge 0
123 ;;
124 esac
125 fi
91063bbc
JH
126}
127
b1bfcae4
JH
128merge_name () {
129 remote="$1"
5be60078
JH
130 rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
131 bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
b1bfcae4
JH
132 if test "$rh" = "$bh"
133 then
134 echo "$rh branch '$remote' of ."
135 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
5be60078 136 git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
b1bfcae4
JH
137 then
138 echo "$rh branch '$truname' (early part) of ."
85295a52
MT
139 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
140 then
141 sed -e 's/ not-for-merge / /' -e 1q \
142 "$GIT_DIR/FETCH_HEAD"
b1bfcae4
JH
143 else
144 echo "$rh commit '$remote'"
145 fi
146}
147
aec7b362 148parse_config () {
b0bf1d8b
PH
149 while test $# != 0; do
150 case "$1" in
151 -n|--no-summary)
152 show_diffstat=false ;;
153 --summary)
154 show_diffstat=t ;;
155 --squash)
156 allow_fast_forward=t squash=t no_commit=t ;;
157 --no-squash)
158 allow_fast_forward=t squash= no_commit= ;;
159 --commit)
160 allow_fast_forward=t squash= no_commit= ;;
161 --no-commit)
162 allow_fast_forward=t squash= no_commit=t ;;
163 --ff)
164 allow_fast_forward=t squash= no_commit= ;;
165 --no-ff)
166 allow_fast_forward=false squash= no_commit= ;;
167 -s|--strategy)
168 shift
169 case " $all_strategies " in
170 *" $1 "*)
171 use_strategies="$use_strategies$1 " ;;
172 *)
173 die "available strategies are: $all_strategies" ;;
174 esac
175 ;;
176 -m|--message)
177 shift
178 merge_msg="$1"
179 have_message=t
180 ;;
181 --)
aec7b362 182 shift
b0bf1d8b
PH
183 break ;;
184 *) usage ;;
185 esac
186 shift
aec7b362 187 done
b0bf1d8b 188 args_left=$#
aec7b362
LH
189}
190
d38eb710
LH
191test $# != 0 || usage
192
193have_message=
aec7b362
LH
194
195if branch=$(git-symbolic-ref -q HEAD)
196then
197 mergeopts=$(git config "branch.${branch#refs/heads/}.mergeoptions")
198 if test -n "$mergeopts"
199 then
b0bf1d8b 200 parse_config $mergeopts --
aec7b362
LH
201 fi
202fi
203
b0bf1d8b
PH
204parse_config "$@"
205while test $args_left -lt $#; do shift; done
91063bbc 206
51e7ecf4 207if test -z "$show_diffstat"; then
5be60078 208 test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
51e7ecf4
AR
209 test -z "$show_diffstat" && show_diffstat=t
210fi
211
17bcdad3
JH
212# This could be traditional "merge <msg> HEAD <commit>..." and the
213# way we can tell it is to see if the second token is HEAD, but some
214# people might have misused the interface and used a committish that
215# is the same as HEAD there instead. Traditional format never would
216# have "-m" so it is an additional safety measure to check for it.
217
218if test -z "$have_message" &&
5be60078
JH
219 second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
220 head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
17bcdad3
JH
221 test "$second_token" = "$head_commit"
222then
223 merge_msg="$1"
224 shift
225 head_arg="$1"
226 shift
5be60078 227elif ! git rev-parse --verify HEAD >/dev/null 2>&1
8092c7f6
JH
228then
229 # If the merged head is a valid one there is no reason to
230 # forbid "git merge" into a branch yet to be born. We do
231 # the same for "git pull".
232 if test 1 -ne $#
233 then
234 echo >&2 "Can merge only exactly one commit into empty head"
235 exit 1
236 fi
237
238 rh=$(git rev-parse --verify "$1^0") ||
239 die "$1 - not something we can merge"
240
5be60078
JH
241 git update-ref -m "initial pull" HEAD "$rh" "" &&
242 git read-tree --reset -u HEAD
8092c7f6
JH
243 exit
244
17bcdad3
JH
245else
246 # We are invoked directly as the first-class UI.
247 head_arg=HEAD
248
249 # All the rest are the commits being merged; prepare
250 # the standard merge summary message to be appended to
251 # the given message. If remote is invalid we will die
252 # later in the common codepath so we discard the error
253 # in this loop.
254 merge_name=$(for remote
255 do
b1bfcae4 256 merge_name "$remote"
5be60078 257 done | git fmt-merge-msg
17bcdad3
JH
258 )
259 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
260fi
5be60078 261head=$(git rev-parse --verify "$head_arg"^0) || usage
91063bbc
JH
262
263# All the rest are remote heads
6ea23343 264test "$#" = 0 && usage ;# we need at least one remote head.
7f9acb2a 265set_reflog_action "merge $*"
6ea23343 266
9954f5b8 267remoteheads=
91063bbc
JH
268for remote
269do
5be60078 270 remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
91063bbc 271 die "$remote - not something we can merge"
9954f5b8 272 remoteheads="${remoteheads}$remotehead "
e0ec1819
SP
273 eval GITHEAD_$remotehead='"$remote"'
274 export GITHEAD_$remotehead
91063bbc 275done
9954f5b8 276set x $remoteheads ; shift
91063bbc 277
6ea23343
JH
278case "$use_strategies" in
279'')
280 case "$#" in
281 1)
5be60078 282 var="`git config --get pull.twohead`"
de811948
SP
283 if test -n "$var"
284 then
285 use_strategies="$var"
286 else
287 use_strategies="$default_twohead_strategies"
288 fi ;;
6ea23343 289 *)
5be60078 290 var="`git config --get pull.octopus`"
de811948
SP
291 if test -n "$var"
292 then
293 use_strategies="$var"
294 else
295 use_strategies="$default_octopus_strategies"
296 fi ;;
6ea23343
JH
297 esac
298 ;;
299esac
300
301for s in $use_strategies
302do
a0050852 303 for ss in $no_fast_forward_strategies
de6f0def
JH
304 do
305 case " $s " in
a0050852
JH
306 *" $ss "*)
307 allow_fast_forward=f
308 break
309 ;;
310 esac
311 done
312 for ss in $no_trivial_strategies
313 do
314 case " $s " in
315 *" $ss "*)
316 allow_trivial_merge=f
de6f0def
JH
317 break
318 ;;
319 esac
320 done
6ea23343
JH
321done
322
13956670
JH
323case "$#" in
3241)
5be60078 325 common=$(git merge-base --all $head "$@")
13956670
JH
326 ;;
327*)
5be60078 328 common=$(git show-branch --merge-base $head "$@")
13956670
JH
329 ;;
330esac
91063bbc
JH
331echo "$head" >"$GIT_DIR/ORIG_HEAD"
332
a0050852 333case "$allow_fast_forward,$#,$common,$no_commit" in
6ea23343 334?,*,'',*)
88f8f0a5 335 # No common ancestors found. We need a real merge.
91063bbc 336 ;;
6ea23343 337?,1,"$1",*)
91063bbc 338 # If head can reach all the merge then we are up to date.
6ea23343 339 # but first the most common case of merging one remote.
7d0c6887 340 finish_up_to_date "Already up-to-date."
91063bbc
JH
341 exit 0
342 ;;
a0050852 343t,1,"$head",*)
91063bbc 344 # Again the most common case of merging one remote.
5be60078
JH
345 echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
346 git update-index --refresh 2>/dev/null
be242d57
BF
347 msg="Fast forward"
348 if test -n "$have_message"
349 then
350 msg="$msg (no commit created; -m option ignored)"
351 fi
5be60078
JH
352 new_head=$(git rev-parse --verify "$1^0") &&
353 git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
be242d57 354 finish "$new_head" "$msg" || exit
a9358240 355 dropsave
91063bbc
JH
356 exit 0
357 ;;
6ea23343 358?,1,?*"$LF"?*,*)
91063bbc
JH
359 # We are not doing octopus and not fast forward. Need a
360 # real merge.
361 ;;
6ea23343 362?,1,*,)
f9d72413 363 # We are not doing octopus, not fast forward, and have only
c82d7117 364 # one common.
5be60078 365 git update-index --refresh 2>/dev/null
a0050852
JH
366 case "$allow_trivial_merge" in
367 t)
c82d7117
SP
368 # See if it is really trivial.
369 git var GIT_COMMITTER_IDENT >/dev/null || exit
370 echo "Trying really trivial in-index merge..."
5be60078
JH
371 if git read-tree --trivial -m -u -v $common $head "$1" &&
372 result_tree=$(git write-tree)
c82d7117
SP
373 then
374 echo "Wonderful."
375 result_commit=$(
a23bfaed 376 printf '%s\n' "$merge_msg" |
5be60078 377 git commit-tree $result_tree -p HEAD -p "$1"
c82d7117
SP
378 ) || exit
379 finish "$result_commit" "In-index merge"
380 dropsave
381 exit 0
382 fi
383 echo "Nope."
384 esac
f9d72413 385 ;;
91063bbc
JH
386*)
387 # An octopus. If we can reach all the remote we are up to date.
388 up_to_date=t
389 for remote
390 do
5be60078 391 common_one=$(git merge-base --all $head $remote)
91063bbc
JH
392 if test "$common_one" != "$remote"
393 then
394 up_to_date=f
395 break
396 fi
397 done
398 if test "$up_to_date" = t
399 then
7d0c6887 400 finish_up_to_date "Already up-to-date. Yeeah!"
91063bbc
JH
401 exit 0
402 fi
403 ;;
404esac
405
e3b59a44
JH
406# We are going to make a new commit.
407git var GIT_COMMITTER_IDENT >/dev/null || exit
408
a9358240
JH
409# At this point, we need a real merge. No matter what strategy
410# we use, it would operate on the index, possibly affecting the
411# working tree, and when resolved cleanly, have the desired tree
412# in the index -- this means that the index must be in sync with
60fa0560 413# the $head commit. The strategies are responsible to ensure this.
91063bbc 414
a9358240
JH
415case "$use_strategies" in
416?*' '?*)
417 # Stash away the local changes so that we can try more than one.
418 savestate
419 single_strategy=no
420 ;;
421*)
deca7e8c 422 rm -f "$GIT_DIR/MERGE_SAVE"
a9358240
JH
423 single_strategy=yes
424 ;;
425esac
91063bbc
JH
426
427result_tree= best_cnt=-1 best_strategy= wt_strategy=
695bf722 428merge_was_ok=
91063bbc
JH
429for strategy in $use_strategies
430do
431 test "$wt_strategy" = '' || {
432 echo "Rewinding the tree to pristine..."
a9358240 433 restorestate
91063bbc 434 }
a9358240
JH
435 case "$single_strategy" in
436 no)
437 echo "Trying merge strategy $strategy..."
438 ;;
439 esac
440
441 # Remember which strategy left the state in the working tree
91063bbc 442 wt_strategy=$strategy
a9358240 443
123ee3ca
JH
444 git-merge-$strategy $common -- "$head_arg" "$@"
445 exit=$?
446 if test "$no_commit" = t && test "$exit" = 0
447 then
695bf722 448 merge_was_ok=t
123ee3ca
JH
449 exit=1 ;# pretend it left conflicts.
450 fi
451
452 test "$exit" = 0 || {
91063bbc
JH
453
454 # The backend exits with 1 when conflicts are left to be resolved,
455 # with 2 when it does not handle the given merge at all.
456
91063bbc
JH
457 if test "$exit" -eq 1
458 then
459 cnt=`{
5be60078
JH
460 git diff-files --name-only
461 git ls-files --unmerged
91063bbc
JH
462 } | wc -l`
463 if test $best_cnt -le 0 -o $cnt -le $best_cnt
464 then
465 best_strategy=$strategy
466 best_cnt=$cnt
467 fi
468 fi
469 continue
470 }
471
472 # Automerge succeeded.
5be60078 473 result_tree=$(git write-tree) && break
91063bbc
JH
474done
475
476# If we have a resulting tree, that means the strategy module
477# auto resolved the merge cleanly.
478if test '' != "$result_tree"
479then
d66424c4
LH
480 if test "$allow_fast_forward" = "t"
481 then
482 parents=$(git show-branch --independent "$head" "$@")
483 else
484 parents=$(git rev-parse "$head" "$@")
485 fi
486 parents=$(echo "$parents" | sed -e 's/^/-p /')
5be60078 487 result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
e1447e38 488 finish "$result_commit" "Merge made by $wt_strategy."
a9358240 489 dropsave
91063bbc
JH
490 exit 0
491fi
492
493# Pick the result from the best strategy and have the user fix it up.
494case "$best_strategy" in
495'')
a9358240 496 restorestate
0c4e95d0
JH
497 case "$use_strategies" in
498 ?*' '?*)
499 echo >&2 "No merge strategy handled the merge."
500 ;;
501 *)
502 echo >&2 "Merge with strategy $use_strategies failed."
503 ;;
504 esac
4275df51 505 exit 2
91063bbc
JH
506 ;;
507"$wt_strategy")
508 # We already have its result in the working tree.
509 ;;
510*)
511 echo "Rewinding the tree to pristine..."
a9358240 512 restorestate
91063bbc 513 echo "Using the $best_strategy to prepare resolving by hand."
a9358240 514 git-merge-$best_strategy $common -- "$head_arg" "$@"
91063bbc
JH
515 ;;
516esac
7d0c6887
JH
517
518if test "$squash" = t
519then
520 finish
521else
522 for remote
523 do
524 echo $remote
525 done >"$GIT_DIR/MERGE_HEAD"
a23bfaed 526 printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
7d0c6887 527fi
deca7e8c 528
695bf722
JH
529if test "$merge_was_ok" = t
530then
531 echo >&2 \
532 "Automatic merge went well; stopped before committing as requested"
533 exit 0
534else
6b94f1e4
JH
535 {
536 echo '
537Conflicts:
538'
539 git ls-files --unmerged |
540 sed -e 's/^[^ ]* / /' |
541 uniq
542 } >>"$GIT_DIR/MERGE_MSG"
b4372ef1 543 git rerere
50ac7408 544 die "Automatic merge failed; fix conflicts and then commit the result."
695bf722 545fi